
/*------------------------------------------------------------------*/
/* --- STC MCU International Limited -------------------------------*/
/* --- STC 1T Series MCU Demo --------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ---------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ---------------------*/
/* --- Web: www.stcai.com ------------------------------------------*/
/* --- BBS: www.stcaimcu.com ---------------------------------------*/
/* If you want to use the program or the program referenced in the  */
/* article, please specify in which data and procedures from STC    */
/*------------------------------------------------------------------*/


#define MAIN_Fosc		24000000L	//ʱ

#define	UART_BaudRate1	115200UL	 /*  */

#include	"..\..\STC8Hxxx.h"


/*************	˵	**************

PWM̶Ϊ, IOʽЧ.

IO:
 PWM4P    PWM3N PWM3P    PWM2N PWM2P    PWM1N PWM1P
 P1.6     P1.5  P1.4     P1.3  P1.2     P1.1  P1.0

ADC: P1.7 
PWMжϺȡP3.3ָʾPWMж.
ADCжϺȡP3.4ָʾADCж.
1ÿ1P3.0 P3.1ADCֵ, תʮASCII.
******************************************/


u16	adc;		//ADC
bit	B_ADC_OK;	//ADCɱ־
bit	B_TX1_Busy;	// æ־



void 	PWMA_config(void);
void	ADC_config(void);
void	UART1_config(void);
void 	Uart1_TxByte(u8 dat);
void 	PrintString1(u8 *puts);


/********************  **************************/
void main(void)
{
	u16	j;
	
	ADC_config();
	PWMA_config(); 
	UART1_config();
	EA = 1;

	P3M1 = 0;
	P3M0 = 0;
	j = 0;

	while (1) 
	{
		if(B_ADC_OK)	//ADC
		{
			B_ADC_OK = 0;	//־
			if(++j >= 10000)	//ADCƵ10KHz, 1뷵һ
			{
				j = 0;
				Uart1_TxByte('A');
				Uart1_TxByte('D');
				Uart1_TxByte('C');
				Uart1_TxByte('0');
				Uart1_TxByte('7');
				Uart1_TxByte('=');				//ADC

				Uart1_TxByte(adc/1000 + '0');
				Uart1_TxByte(adc%1000/100 + '0');
				Uart1_TxByte(adc%100/10 + '0');
				Uart1_TxByte(adc%10 + '0');
				Uart1_TxByte(0x0d);
				Uart1_TxByte(0x0a);
			}
		}
	}
}


//========================================================================
// : void  delay_ms(u8 ms)
// : ʱ
// : ms,Ҫʱms, ֻ֧1~255ms. ԶӦʱ.
// : none.
// 汾: VER1.0
// : 2013-4-1
// ע: 
//========================================================================
void  delay_ms(u8 ms)
{
     u16 i;
	 do
	 {
	 	i = MAIN_Fosc / 10000;
		while(--i)	;
     }while(--ms);
}


//========================================================================
// : void	ADC_config(void)
// : ADCú.
// : None
// : none.
// 汾: V1.0, 2021-12-23
//========================================================================
#define ADC_POWER	(1<<7)	/* ADCԴ */
#define ADC_START	(1<<6)	/* Զ0 */
#define ADC_FLAG	(1<<5)	/* 0 */
#define ADC_EPWMT	(1<<4)	/* PWMADC */

#define	RES_FMT		(1<<5)	/* ADCʽ 0: , ADC_RES: D9 D8 D7 D6 D5 D4 D3 D2, ADC_RESL: D1 D0 0  0  0  0  0  0 */
							/*             1: Ҷ, ADC_RES: 0  0  0  0  0  0  D9 D8, ADC_RESL: D7 D6 D5 D4 D3 D2 D1 D0 */
#define	ADC_SPEED	1		/* 0~15, ADCʱ = SYSclk/2/(n+1) */

#define CSSETUP		(0<<7)	/* 0~1,  ADCͨѡʱ      0: 1ADCʱ, 1: 2ADCʱ,  Ĭ0(Ĭ1ADCʱ)	*/
#define CSHOLD		(1<<5)	/* 0~3,  ADCͨѡ񱣳ʱ  (n+1)ADCʱ, Ĭ1(Ĭ2ADCʱ)					*/
#define SMPDUTY		20		/* 10~31, ADCģźŲʱ  (n+1)ADCʱ, Ĭ10(Ĭ11ADCʱ)				*/
							/* ADCתʱ: 10λADC̶Ϊ10ADCʱ, 12λADC̶Ϊ12ADCʱ. 				*/
void	ADC_config(void)
{
	P1n_pure_input(0x80);	//ҪADCIO
	ADC_CONTR = ADC_POWER | ADC_EPWMT | 7;	//ADC on + channel
	ADCCFG    = RES_FMT + ADC_SPEED;
	P_SW2    |=  0x80;	//XSFR
	ADCTIM = CSSETUP + CSHOLD + SMPDUTY;
	delay_ms(10);		//ȴADCԴȶ
	EADC = 1;			//ADCж
}

//========================================================================
// : void ADC_ISR (void) interrupt ADC_VECTOR
// : ADCжϺ.
// : none.
// : none.
// 汾: VER1.0
// : 2018-4-1
// ע: 
//========================================================================
void ADC_ISR (void) interrupt ADC_VECTOR
{
	ADC_CONTR &= ~ADC_FLAG;		//жϱ־
	adc = (u16)ADC_RES * 256 + (u16)ADC_RESL;	//ADC
	B_ADC_OK = 1;	//־ADC
	ADC_RES  = 0;
	ADC_RESL = 0;

	P34 = ~P34;		//ȡһIO, ָʾADCж
}


//========================================================================
// : void PWMA_config(void)
// : PWMAú.
// : None
// : none.
// 汾: V1.0, 2021-12-23
//========================================================================
void PWMA_config(void)
{
	P_SW2 |= 0x80;		//SFR enable   

	PWMA_PSCR = 0x0000;	// ԤƵĴ, Ƶ Fck_cnt = Fck_psc/(PSCR[15:0}+1), ضPWMƵ = SYSclk/((PSCR+1)*(AAR+1)), PWMƵ = SYSclk/((PSCR+1)*(AAR+1)*2).
	PWMA_DTR  = 24;		// ʱ, n=0~127: DTR= n T,   0x80 ~(0x80+n), n=0~63: DTR=(64+n)*2T,  
						//				0xc0 ~(0xc0+n), n=0~31: DTR=(32+n)*8T,   0xE0 ~(0xE0+n), n=0~31: DTR=(32+n)*16T,
	PWMA_ARR = 2400;	// ԶװؼĴ,  PWM
	PWMA_CCER1  = 0;
	PWMA_CCER2  = 0;
	PWMA_SR1    = 0;
	PWMA_SR2    = 0;
	PWMA_ENO    = 0;
	PWMA_PS     = 0;
	PWMA_IER    = 0;
//	PWMA_ISR_En = 0;

	PWMA_CCMR1  = 0x68;		// ͨģʽ, PWMģʽ1, Ԥװ
	PWMA_CCR1   = 480;		// Ƚֵ, ռձ(ߵƽʱ)
	PWMA_CCER1 |= 0x05;		// Ƚ, ߵƽЧ
	PWMA_PS    |= 0;		// ѡIO, 0:ѡP1.0 P1.1, 1:ѡP2.0 P2.1, 2:ѡP6.0 P6.1, 
	PWMA_ENO   |= 0x03;		// IO,  bit7: ENO4N, bit6: ENO4P, bit5: ENO3N, bit4: ENO3P,  bit3: ENO2N,  bit2: ENO2P,  bit1: ENO1N,  bit0: ENO1P
//	PWMA_IER   |= 0x02;		// ʹж

	PWMA_CCMR2  = 0x68;		// ͨģʽ, PWMģʽ1, Ԥװ
	PWMA_CCR2   = 960;		// Ƚֵ, ռձ(ߵƽʱ)
	PWMA_CCER1 |= 0x50;		// Ƚ, ߵƽЧ
	PWMA_PS    |= (0<<2);	// ѡIO, 0:ѡP1.2 P1.3, 1:ѡP2.2 P2.3, 2:ѡP6.2 P6.3, 
	PWMA_ENO   |= 0x0C;		// IO,  bit7: ENO4N, bit6: ENO4P, bit5: ENO3N, bit4: ENO3P,  bit3: ENO2N,  bit2: ENO2P,  bit1: ENO1N,  bit0: ENO1P
//	PWMA_IER   |= 0x04;		// ʹж

	PWMA_CCMR3  = 0x68;		// ͨģʽ, PWMģʽ1, Ԥװ
	PWMA_CCR3   = 1440;		// Ƚֵ, ռձ(ߵƽʱ)
	PWMA_CCER2 |= 0x05;		// Ƚ, ߵƽЧ
	PWMA_PS    |= (0<<4);	// ѡIO, 0:ѡP1.4 P1.5, 1:ѡP2.4 P2.5, 2:ѡP6.4 P6.5, 
	PWMA_ENO   |= 0x30;		// IO,  bit7: ENO4N, bit6: ENO4P, bit5: ENO3N, bit4: ENO3P,  bit3: ENO2N,  bit2: ENO2P,  bit1: ENO1N,  bit0: ENO1P
//	PWMA_IER   |= 0x08;		// ʹж

	PWMA_CCMR4  = 0x68;		// ͨģʽ, PWMģʽ1, Ԥװ
	PWMA_CCR4   = 1920;		// Ƚֵ, ռձ(ߵƽʱ)
	PWMA_CCER2 |= 0x50;		// Ƚ, ߵƽЧ
	PWMA_PS    |= (0<<6);	// ѡIO, 0:ѡP1.6 P1.7, 1:ѡP2.6 P2.7, 2:ѡP6.6 P6.7, 3:ѡP3.3 P3.4
	PWMA_ENO   |= 0x40;		// IO,  bit7: ENO4N, bit6: ENO4P, bit5: ENO3N, bit4: ENO3P,  bit3: ENO2N,  bit2: ENO2P,  bit1: ENO1N,  bit0: ENO1P
//	PWMA_IER   |= 0x10;		// ʹж

	PWMA_BKR    = 0x80;		// ʹ ൱ܿ
	PWMA_CR1    = 0x81;		// ʹܼ, ԶװؼĴ, ضģʽ, ϼ,  bit7=1:дԶװؼĴ(ڲᱻ), =0:ֱдԶװؼĴ(ڿܻҵ)
	PWMA_EGR    = 0x01;		//һθ¼, ԤƵ, װԤƵĴֵ
//	PWMA_ISR_En = PWMA_IER;	//ñ־ͨ1~4жϴ

	PWMA_CR2    = 0x20;		// ¼ΪTRG0, ڴADC
	PWMA_IER    = 0x01;		//ж
}

//	PWMA_PS   = (0<<6)+(0<<4)+(0<<2)+0;	//ѡIO, 4Ӹߵ()ӦPWM1 PWM2 PWM3 PWM4, 0:ѡP1.x, 1:ѡP2.x, 2:ѡP6.x, 
//  PWMA_PS    PWM4N PWM4P    PWM3N PWM3P    PWM2N PWM2P    PWM1N PWM1P
//    00       P1.7  P1.6     P1.5  P1.4     P1.3  P1.2     P1.1  P1.0
//    01       P2.7  P2.6     P2.5  P2.4     P2.3  P2.2     P2.1  P2.0
//    02       P6.7  P6.6     P6.5  P6.4     P6.3  P6.2     P6.1  P6.0
//    03       P3.3  P3.4      --    --       --    --       --    --


//========================================================================
// : void PWMA_ISR(void) interrupt PWMA_VECTOR
// : PWMAжϴ.
// : None
// : none.
// 汾: V1.0, 2021-6-1
//========================================================================
void PWMA_ISR(void) interrupt PWMA_VECTOR
{
	u8	sr1, sr2;
	sr1 = PWMA_SR1;	//Ϊ˿, жϱ־һֲ
	PWMA_SR1 = 0;	//жϱ־
	sr2 = PWMA_SR2;	//Ϊ˿, жϱ־һֲ
	PWMA_SR2 = 0;	//жϱ־

	if(sr1 & 0x01)	//¼ж, ӦPWMڿʼʱ
	{
		P33 = ~P33;		//ȡһIO, ָʾPWMAж
	}
}


//========================================================================
// : void	UART1_config(u8 brt)
// : UART1ʼ
// : brt: ѡ, 2: ʹTimer2, ֵ: ʹTimer1.
// : none.
// 汾: VER1.0
// : 2016-4-28
// ע: 
//========================================================================
void	UART1_config(void)	//
{
	TR1 = 0;
	AUXR &= ~0x01;		//S1 BRT Use Timer1;
	AUXR |=  (1<<6);	//Timer1 set as 1T mode
	TMOD &= ~(1<<6);	//Timer1 set As Timer
	TMOD &= ~0x30;		//Timer1_16bitAutoReload;
	TH1 = (65536UL - (MAIN_Fosc / 4) / UART_BaudRate1) / 256;
	TL1 = (65536UL - (MAIN_Fosc / 4) / UART_BaudRate1) % 256;
	ET1 = 0;	//ֹж
	TR1  = 1;

	SCON = (SCON & 0x3f) | (1<<6);	// 8λ, 1λʼλ, 1λֹͣλ, У
	REN = 1;	//
//	PS  = 1;	//ȼж
	ES  = 1;	//ж
	P_SW1 = P_SW1 & 0x3f;				P3n_push_pull(0x02);	//л P3.0 P3.1
//	P_SW1 = (P_SW1 & 0x3f) | (1<<6);	P3n_push_pull(0x80);	//лP3.6 P3.7
//	P_SW1 = (P_SW1 & 0x3f) | (2<<6);	P1n_push_pull(0x80);	//лP1.6 P1.7 (ʹڲʱ)

	B_TX1_Busy  = 0;
}


//========================================================================
// : void Uart1_TxByte(u8 dat)
// : 1һֽں.
// : none.
// : none.
// 汾: VER1.0
// : 2016-4-28
// ע: 
//========================================================================
void Uart1_TxByte(u8 dat)
{
	B_TX1_Busy = 1;		//־æ
	SBUF = dat;			//һֽ
	while(B_TX1_Busy);	//ȴ
}


//========================================================================
// : void UART1_int (void) interrupt UART1_VECTOR
// : 1жϺ
// : none.
// : none.
// 汾: VER1.0
// : 2016-4-28
// ע: 
//========================================================================
void UART1_int (void) interrupt UART1_VECTOR
{
	if(RI)
	{
		RI = 0;
	}

	if(TI)
	{
		TI = 0;
		B_TX1_Busy = 0;
	}
}



